//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Boids
//    v:0.1 12/09/2002
//
//  This program implements Boids as a demonstration of emergent behaviour
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package boid;

import java.awt.*;
import java.util.*;
import vabase.*;

/** Classe de gestion des boids */
public class Cboid extends Cprocess {
  /** paramtres par dfaut */
  static final int POP=30;
  static final double DISTANCE_MINI=2;
  static final int COHESION=25;
  static final int EVITE=20;
  static final int ALIGNE=25;
  static final int OBJECTIF=50;
  static final int VENT=5;
  /** Pointeur sur l'interface utilisateur */
  private boidUI appUI;
  /** Vue */
  vueBoid boidVue;
  /** Population */
  Vector lesIndividus;
  /** Taille de la population */
  int taillePopulation;
  /** Distance minimum entre individus */
  double distanceMini=DISTANCE_MINI;
  /** Paramtre de cohsion */
  int valCohesion=COHESION;
  /** Paramtre d'vitement */
  int valEvite=EVITE;
  /** Paramtre d'alignement */
  int valAligne=ALIGNE;
  /** Paramtre d'objectif */
  int valObjectif=OBJECTIF;
  /** Vent */
  int valVent=VENT;
  /** Position de l'objectif */
  CposXY posObjectif=new CposXY();
  /** Objectif actif ? */
  boolean objExiste=false;
  /** Utilis pour dispersion */
  int disperseGen;

  /** Constructeur */
  public Cboid(boidUI ui, int pop) {
    super(ui);
    appUI=ui;
    boidVue=new vueBoid(this, Color.white, Color.black);
    vue=(Cvue)boidVue;
    disperseGen=1000;
    setTempo(20);
    setNewPb(pop);
  }
  /** Initialisation nouveau problme */
  public void setNewPb(int pop) {
    setParam(COHESION, EVITE, ALIGNE, OBJECTIF, VENT);
    setNewPop(pop);
    placeObjectif(boidVue.lLargeur/2, boidVue.lHauteur/2);
  }
  /** Mise  jour des paramtres */
  public void setParam(int co, int ev, int al, int ob, int ve) {
    setCohesion(co);
    setEvite(ev);
    setAligne(al);
    setObjectif(ob);
    setVent(ve);
  }
  /** Cration d'une nouvelle population */
  public void setNewPop(int p) {
    taillePopulation=p;
    generation=0;
    lesIndividus=null;
    lesIndividus=new Vector(taillePopulation);
    for(int i=0;i<taillePopulation;i++)
      lesIndividus.addElement(new Cindividu(this,i));
  }
  /** Initialisation/MAJ de la vue */
  public void initVue() {
    boidVue.setNewTaille();
  }
  /** Affichage de la population */
  public void affPop() {
    boidVue.affPop();
  }
  /** Place l'objectif */
  public void placeObjectif(float x, float y) {
    objExiste=true;
    posObjectif.valX=x;
    posObjectif.valY=y;
  }
  /** Supprime l'objectif */
  public void supprObjectif() {
    objExiste=false;
  }
  /** Dispersion */
  public void disperse() {
    disperseGen=0;
  }
  /** Cration d'une nouvelle gnration */
  public void geneSuiv() {
    for(int i=0;i<taillePopulation;i++)
      ((Cindividu)lesIndividus.elementAt(i)).calcPos();
    generation++;
    disperseGen++;
    boidVue.peintFond();
    affPop();
    boidVue.repaint();
  }
  /** Fixe la paramtre de cohesion */
  public void setCohesion(int c) {
    valCohesion=c;
  }
  /** Fixe la paramtre d'vitement */
  public void setEvite(int c) {
    valEvite=c;
  }
  /** Fixe la paramtre d'alignement */
  public void setAligne(int c) {
    valAligne=c;
  }
  /** Fixe le paramtre d'objectif */
  public void setObjectif(int c) {
    valObjectif=c;
  }
  /** Vent */
  public void setVent(int c) {
    valVent=c;
  }
}