//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Boids
//    v:0.1 12/09/2002
//
//  This program implements Boids as a demonstration of emergent behaviour
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package boid;

import java.awt.*;
import vabase.*;

/** Classe de gestion de vue, base graphique */
public class vueBoid extends Cvue {

  /** Pointeur sur l'algorithme */
  private Cboid boids;
  /** Constructeur par dfaut */
  public vueBoid(Cboid b) {
    super(Color.white, Color.black, Cvue.REPRANISOTROPIC);
    boids=b;
  }
  /** Constructeur avec couleurs */
  public vueBoid(Cboid b, Color c, Color f) {
    super(c, f, Cvue.REPRANISOTROPIC);
    boids=b;
  }
  /** Fixe nouvelle taille */
  public void setNewTaille() {
    redimGrBuff();
    repaint();
  }
  /** Peint le fond */
  public void peintFond() {
    effaceFond();
    if(boids.objExiste) {
      Color colCrt=grBuff.getColor();
      grBuff.setColor(Color.red);
      grBuff.fillRect(lToRX(boids.posObjectif.valX-lLargeur/200),
                        lToRY(boids.posObjectif.valY-lHauteur/200),
                        lLongueurToRX(lLargeur/100),
                        lLongueurToRY(lHauteur/100));
      grBuff.setColor(colCrt);
    }
  }
  /** Affichage d'un individu */
  public void affBoid(Cindividu boid) {
    double angle;
    angle=Math.atan(boid.vitesse.valY/boid.vitesse.valX);
    grBuff.drawLine(
      lToRX(boid.position.valX),
      lToRY(boid.position.valY),
      lToRX((float)(boid.position.valX-(lLargeur/200.0*Math.cos(angle)))),
      lToRY((float)(boid.position.valY-(lHauteur/200.0*Math.sin(angle)))));
  }
  /** Affichage de la population */
  public void affPop() {
    for(int i=0;i<boids.taillePopulation;i++)
      affBoid( (Cindividu)boids.lesIndividus.elementAt(i));
  }

  /** Gestion de l'objectif */
  public boolean mouseDown(Event e,int x,int y) {
    if(!boids.isRunning)
      return(false);
    if(e.clickCount>1)
      boids.supprObjectif();
    else
      boids.placeObjectif(rToLX(x),rToLY(y));
    repaint();
    return(true);
  }
}

